--[[
  A Cocos2D like particles effect for Gideros
  based on an idea of Seb Lee-Delisle (www.sebleedelisle.com)
  
  All classes have been modified by
  Bill Rigas (www.thepdacorner.com)
  
  Please feel free to make any corrections/amendments
  but be so kind to inform the community.
]]

require('mobdebug').start()

stage:setOrientation(Stage.PORTRAIT)

application:setBackgroundColor(0x000000)
application:setKeepAwake(true)

lbl = TextField.new(TTFont.new("arial.ttf", 18), "")
lbl:setTextColor(0xffffff)
lbl:setPosition(4, application:getDeviceHeight()-20)
stage:addChild(lbl)

-- First add the snow particle from a lua table
snow = ccSnowParticle.new(part_Snow)
stage:addChild(snow)

-- Finally add an explosion particle from a Cocos2D plist file
function plist2table()
	local cfile = io.open("explosion.plist", "r")
	local tbl = nil
	
	if cfile then
		local contents = cfile:read("*all")
		io.close(cfile)
		tbl = plistParser(contents)
	end
		
	return tbl
end

explosion = ccExplosionParticle.new(plist2table(), false)
stage:addChild(explosion)

function onMouseDown(event)
  -- Activate a disabled particle
  if explosion:isStopped() then
    explosion:start()
  end
  
  -- This will play the effect until its duration expires
  explosion:restart() 
end

function onEnterFrame(event)
  local fps = 1 / event.deltaTime
  lbl:setText(string.format("FPS: %d", fps))
end

stage:addEventListener(Event.MOUSE_DOWN, onMouseDown)
stage:addEventListener(Event.ENTER_FRAME, onEnterFrame)
